% Demo cours 2 -- GBM6103A

% Effet de la causalit
%
%    Copyright (C) 2007-2014 Yves Goussard
%
%    This program is free software: you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation, either version 3 of the License, or
%    (at your option) any later version.
%
%    This program is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License
%    along with this program.  If not, see <http://www.gnu.org/licenses/>.

Te = 1/25;
T = 10;
t = 0:Te:T;
N = 256;

a = 0.9;

x = zeros(size(t));
x(51:56) = 1;
x(126:176) = ones(size(x(126:176)));

z = filter([1], [1, -a], x);
y1 = filter([1], [1, -a], z);
y2 = fliplr(filter([1], [1, -a], fliplr(z)));

nu = (0:N-1)/N;
nu(find(nu >= 0.5)) = nu(find(nu >= 0.5)) - 1;
nu = fftshift(nu);

H1 = 1./abs(fftshift(fft([1, -2*a, a^2], N)));
H2 = 1./abs(fftshift(fft([-a, 1+a^2, -a], N)));

close all
figure(1)
set(gcf, 'Windowstyle', 'Docked')

subplot(2,1,1)
plot(nu, H1, 'b')
title('MODULE DE LA RPONSE FRQUENTIELLE, FILTRE 1')

subplot(2,1,2)
plot(nu, H2, 'b')
title('MODULE DE LA RPONSE FRQUENTIELLE, FILTRE 2')

disp('Taper <Enter> pour poursuivre')
pause




figure(2)
set(gcf, 'Windowstyle', 'Docked')

subplot(3,1,1)
plot(t, x, '.r')
set(gca, 'Ylim', [-0.1, 1.1])
grid on
title('SIGNAL D''ENTRE')

disp('Taper <Enter> pour poursuivre')
pause

for k = 1:length(t)
  subplot(3,1,1)
  plot(t, x, '.r'), hold on
  plot(t(1:k), x(1:k), '.b'), hold off
  set(gca, 'XLim', [t(1) t(length(t))], 'YLim', [-0.1, 1.1])
  title('SIGNAL D''ENTRE')
  grid on
%  drawnow
  
  subplot(3,1,2)
  plot(t(1:k), y1(1:k), '.b')
  set(gca, 'XLim', [t(1) t(length(t))], 'YLim', [-10 110])
  title('SIGNAL DE SORTIE, FILTRE 1')
  grid on
  drawnow
end

disp('Taper <Enter> pour poursuivre')
pause

for k = 1:length(t)
  subplot(3,1,1)
  plot(t, x, '.r'), hold on
  plot(t(1:k), x(1:k), '.b'), hold off
  set(gca, 'XLim', [t(1) t(length(t))], 'YLim', [-0.1, 1.1])
  title('SIGNAL D''ENTRE')
  grid on
%  drawnow
   
  subplot(3,1,3)
  plot(t(1:k), y2(1:k), '.b')
  set(gca, 'XLim', [t(1) t(length(t))], 'YLim', [-10 110])
  title('SIGNAL DE SORTIE, FILTRE 2')
  grid on
  drawnow
end

