% Demo cours 2 -- GBM6103A
%
% Importance de la stabilit 
%
%    Copyright (C) 2007-2014  Yves Goussard
%
%    This program is free software: you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation, either version 3 of the License, or
%    (at your option) any later version.
%
%    This program is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License
%    along with this program.  If not, see <http://www.gnu.org/licenses/>.

Te = 1/25;
T = 10;
t = 0:Te:T;
randn('seed', 0)
x = randn(size(t)); % Entre gaussienne

a1 = -0.9;
a2 = 1.02;
y1 = filter([1], [1, a1], x);
y2 = filter([1], [1, a2], x);

close all
figure(1)
set(gcf, 'Windowstyle', 'Docked')

subplot(3,1,1)
plot(t, x, 'r'), grid on
set(gca, 'YLim', [-3 3])
title('SIGNAL D''ENTRE')

disp('Taper <Enter> pour poursuivre')
pause
figure(1)

for k = 1:length(t)
  subplot(3,1,1)
  plot(t, x, 'r'), hold on
  plot(t(1:k), x(1:k), 'b'), hold off
  set(gca, 'XLim', [t(1) t(length(t))], 'YLim', [-3 3])
  title('SIGNAL D''ENTRE')
  grid on
%  drawnow
  
  subplot(3,1,2)
  plot(t(1:k), y1(1:k), 'b')
  set(gca, 'XLim', [t(1) t(length(t))], 'YLim', [-10 10])
  title('SIGNAL DE SORTIE, FILTRE 1')
  grid on
  drawnow
end

disp('Taper <Enter> pour poursuivre')
pause
figure(1)

for k = 1:length(t)
  subplot(3,1,1)
  plot(t, x, 'r'), hold on
  plot(t(1:k), x(1:k), 'b'), hold off
  set(gca, 'XLim', [t(1) t(length(t))], 'YLim', [-3 3])
  title('SIGNAL D''ENTRE')
  grid on
%  drawnow
  
  subplot(3,1,3)
  plot(t(1:k), y2(1:k), 'b')
  set(gca, 'XLim', [t(1) t(length(t))], 'YLim', [-10 10])
  title('SIGNAL DE SORTIE, FILTRE 2')
  grid on
  drawnow
end

disp('Taper <Enter> pour poursuivre')
pause

figure(1)
set(gca, 'YLimmode', 'auto')


